from init import *
from widgets import *


sign_abrev = ["Ar", "Ta", "Ge", "Cn", "Le", "Vi", "Li", "Sc", "Sg", "Cp", "Aq", "Pi"]
planet_names = ["Moon", "Sun", "Mercury", "Venus", "Mars", "Jupiter", "Saturn", "Uranus", "Neptune", "Pluto", \
               "Eris", "Sedna", "Mean Node", "True Node", "Eastpoint", "Vertex" ]
planet_abrev = ["Mo", "Su", "Me", "Ve", "Ma", "Ju", "Sa", "Ur", "Ne", "Pl", "Er", "Se", "No", "No",  "Ep", "Vx"]
default_ea = {"0": [3.0, 7.0, 10.0], "180": [3.0, 7.0, 10.0], "90": [3.0, 6.0, 7.5], "45": [1.0, 2.0, 0], "120": [3.0, 6.0, 7.5], \
              "60": [3.0, 6.0, 7.5], "30": [0, 0, 0]}       
default_ma = {"0": [3.0, 0, 0], "180": [3.0, 0, 0], "90": [3.0, 0, 0], "45": [0, 0, 0]}

ingresses = ["Capsolar", "Cansolar", "Arisolar", "Libsolar", "Caplunar", "Canlunar", "Arilunar", "Liblunar"]

pos_sign = {"Mo": ["Cn", "Ta"], "Su": ["Le", "Ar"], "Me": ["Ge" ,"Vi"], "Ve": ["Ta", "Li", "Pi"], "Ma": ["Sc", "Cp"],
            "Ju": ["Sg", "Cn"], "Sa": ["Cp", "Li"], "Ur": ["Aq"], "Ne": ["Pi"], "Pl": ["Ar"], "Er": [], "Se": [], "No": []}
            
neg_sign = {"Mo": ["Cp", "Sc"], "Su": ["Aq", "Li"], "Me": ["Sg" ,"Pi"], "Ve": ["Sc", "Ar", "Vi"], "Ma": ["Ta", "Cn"],
            "Ju": ["Ge", "Cp"], "Sa": ["Cn", "Ar"], "Ur": ["Le"], "Ne": ["Vi"], "Pl": ["Li"], "Er": [], "Se": [], "No": []}

DS =  u'\N{DEGREE SIGN}'

DS =  u'\N{DEGREE SIGN}'
DQ = '"'
SQ = "'"

def main_angularity_curve(a):
    if a <= 10: a *= 6
    elif a > 10 and a <= 40: a = 2 * a + 40 
    elif a > 40 and a <= 60: a *= 3
    else: a = 6 * a - 180
    return math.cos(math.radians(a))

def main_angularity_curve_2(a):
    if a > 45: a = 90 - a
    if a <= 10: a *= 6
    elif a > 10 and a <= 35: a = 2.4 * a + 36
    else: a = 6 * a - 90
    return math.cos(math.radians(a))
    
def minor_angularity_curve(a):
    if a <=2: x = 3 * a / 2
    else: x = (a - 2) * 7 + 3
    a = x * 6
    return math.cos(math.radians(a))
    
def inrange(value, center, tol):
    return value >= center - tol and value <= center + tol
    
def zod_min(value):
    value %= 360
    deg = int(value)
    min = round((value - deg) * 60)
    d = 0
    s = 0
    if min == 60:
        if deg % 30 == 29: 
            d = 30 
            s = -1
        min = 0
        deg += 1
    return f"{(deg % 30) or d:2d}{sign_abrev[(deg // 30) + s]}{min:2d}"
    
def zod_sec(value):
    value %= 360
    deg = int(value) 
    value = (value - deg) * 60
    min = int(value)
    value = (value - min) * 60
    sec = round(value)
    d = 0
    s = 0
    if sec == 60:
        sec = 0
        min += 1
    if min == 60:
        if deg % 30 == 29: 
            d = 30  
            s = -1
        min = 0
        deg += 1 
    return f"{(deg % 30) or d:2d}{sign_abrev[deg // 30 + s]}{min:2d}'{sec:2d}\""
    
def center(value, width = 33):
    if len(value) > width:  value = value[0:width]
    left = (width - len(value)) // 2
    left = " " * left
    right = (width + 1 - len(value)) // 2
    right = " " * right
    return left  + value + right
    
def left(value, width):
    if len(value) > width:  value = value[0:width]
    return value + " " * (width - len(value))
    
def right(value, width):
    if len(value) > width:  value = value[0:width]
    return " " * (width - len(value)) + value
    
def fmt_hms(time):
    day = 0
    if time >= 24:
        day  = 1
        time -= 24
    elif time < 0:
        day = -1
        time += 24
    hour = int(time)
    time = (time - hour) * 60
    min = int(time)
    time = (time - min) * 60
    sec = round(time)
    if sec == 60 :
        sec = 0
        min += 1
    if min == 60:
        min = 0
        hour += 1
    if hour == 24: 
        hour = 0
        day += 1
    if day == 0: day = ""
    elif day == 2: day = " +2 days"
    else: day = f" {day:+d} day"
    return f"{hour:2d}:{min:02d}:{sec:02d}{day}" 
    
def fmt_lat(value, nosec = False):
    sym = "N"
    if value < 0:
        sym = "S"
        value = -value
    deg = int(value)
    value = (value - deg) * 60
    if nosec:
        min = round(value)
        sec = 0
    else:
        min = int(value)
        value = (value - min) * 60
        sec = round(value)
    if sec == 60:
        min += 1 
        sec = 0
    if min == 60: 
        deg += 1
        min = 0
    if nosec: return f"{deg:2d}{sym}{min:2d}"
    return f"{deg:2d}{sym}{min:2d}'{sec:2d}{DQ}"    
    
def fmt_long(value):
    sym = "E"
    if value < 0:
        sym = "W"
        value = -value
    deg = int(value)
    value = (value - deg) * 60
    min = int(value)
    value = (value - min) * 60
    sec = round(value)
    if sec == 60:
        min += 1
        sec = 0
    if min == 60:
        deg += 1
        min = 0  
    return f"{deg:3d}{sym}{min:2d}'{sec:2d}{DQ}" 
    
def fmt_dms(value):
    deg = int(value)
    value = (value - deg) * 60
    min = int(value)
    value = (value - min) * 60
    sec = round(value)
    if sec == 60 :
        sec = 0
        min += 1
    if min == 60:
        min = 0
        deg += 1
    return f"{deg:2d}{DS}{min:2}'{sec:2}{DQ}"
    
def fmt_dm(value, noz = False):
    deg = int(value)
    value = (value - deg) * 60
    min = round(value)
    if min == 60:
        min = 0
        deg += 1
    if noz: return f"{deg:2d}{DS}{min:2}'"
    return f"{deg:02d}{DS}{min:02}'"
    
def s_dm(value):
    if value < 0: return f"-{fmt_dm(-value, True)}"
    elif value > 0: return f"+{fmt_dm(value, True)}"
    else: return f" {fmt_dm(0)}"
        
def s_ms(value):
    if value < 0: s = "-"
    elif value > 0: s = "+"
    else: s = " "
    value = abs(value) * 60
    min = int(value)
    value = (value - min) * 60
    sec = round(value)
    if sec == 60:
        sec = 0
        min += 1
    return f"{s}{min:2}'{sec:2}\""
        
def display(chart, planet, prefix, pa_only = False):
    pd = chart[planet] 
    index = planet_names.index(planet)
    pa = planet_abrev[index]
    if pa_only: return prexfix + pa
    d = prefix + pa + " " + zod_min(pd[0]) 
    if index < 14:
        d += " " + fmt_dm(pd[-1] % 30)
        d = d[0:-1]
    else:
        d = center(d, 16)
    return d
    